/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;

import android.content.Context;
import android.database.Cursor;
import android.util.Log;
import android.view.View;
import android.view.ViewGroup;
import android.widget.CursorAdapter;

import net.micode.notes.data.Notes;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;


/**
 * @projectName（项目名称）: xiaomi label
 * @package（包）: ui
 * @className（类名称）: NotesListAdapter
 * @description（类描述）: 直译为便签表连接器，继承了CursorAdapter，实现的是鼠标和编辑便签链接
 * @author（创建人）: zhangchaoqun
 * @createDate（创建时间）: datetime
 * @updateUser（修改人）: user
 * @updateDate（修改时间）: datetime
 * @updateRemark（修改备注）: 说明本次修改内容
 * @version（版本）: v1.0
 */
public class NotesListAdapter extends CursorAdapter {
    private static final String TAG = "NotesListAdapter";
    private Context mContext;
    private HashMap<Integer, Boolean> mSelectedIndex;
    private int mNotesCount;//便签数
    private boolean mChoiceMode;//选择模式标记


    /**
     * @projectName（项目名称）: xiaomi label
     * @package（包）: ui
     * @className（类名称）: AppWidgetAttribute
     * @description（类描述）: 桌面widget的属性，包括编号和类型
     * @author（创建人）: zhangchaoqun
     * @createDate（创建时间）: datetime
     * @updateUser（修改人）: user
     * @updateDate（修改时间）: datetime
     * @updateRemark（修改备注）: 说明本次修改内容
     * @version（版本）: v1.0
     */
    public static class AppWidgetAttribute {
        public int widgetId;
        public int widgetType;
    };


    /**
     * @description 描述:初始化便签链接器，根据传进来的内容设置相关变量
     * @param 参数1:context
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:返回NotesListAdapter实例化对象
     * @author zhangchaoqun
     */
    public NotesListAdapter(Context context) {
        //父类对象置空
        super(context, null);
        //新建选项下标的hash表
        mSelectedIndex = new HashMap<Integer, Boolean>();
        mContext = context;
        mNotesCount = 0;
    }


    /**
     * @description 描述:新建一个视图来存储光标所指向的数据，使用兄弟类NotesListItem新建一个项目选项
     * @param 参数1:context
     * @param 参数2:cursor
     * @param 参数3:parent
     * @return 返回值:View视图
     * @author zhangchaoqun
     */
    @Override
    public View newView(Context context, Cursor cursor, ViewGroup parent) {
        return new NotesListItem(context);
    }


    /**
     * @description 描述:将已经存在的视图和鼠标指向的数据进行捆绑
     * @param 参数1:view
     * @param 参数2:context
     * @param 参数3:cursor
     * @return 返回值:void
     * @author zhangchaoqun
     */
    @Override
    public void bindView(View view, Context context, Cursor cursor) {
        //若view是NotesListItem的一个实例
        if (view instanceof NotesListItem) {
            //则新建一个项目选项并且用bind跟将view和鼠标，内容，便签数据捆绑在一起
            NoteItemData itemData = new NoteItemData(context, cursor);
            ((NotesListItem) view).bind(context, itemData, mChoiceMode,
                    isSelectedItem(cursor.getPosition()));
        }
    }


    /**
     * @description 描述:设置勾选框
     * @param 参数1:position
     * @param 参数2:checked
     * @param 参数3:
     * @return 返回值:void
     * @author zhangchaoqun
     */
    public void setCheckedItem(final int position, final boolean checked) {
        //根据定位和是否勾选设置下标
        mSelectedIndex.put(position, checked);
        //在修改后刷新activity
        notifyDataSetChanged();
    }


    /**
     * @description 描述:判断单选按钮是否勾选
     * @param 参数1:
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:bool是否勾选
     * @author zhangchaoqun
     */
    public boolean isInChoiceMode() {
        return mChoiceMode;
    }


    /**
     * @description 描述:设置单项选项框，重置下标并且根据参数mode设置选项
     * @param 参数1:mode
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:void
     * @author zhangchaoqun
     */
    public void setChoiceMode(boolean mode) {
        mSelectedIndex.clear();
        mChoiceMode = mode;
    }


    /**
     * @description 描述:选择全部选项
     * @param 参数1:checked
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:void
     * @author zhangchaoqun
     */
    public void selectAll(boolean checked) {
        //获取光标位置
        Cursor cursor = getCursor();
        //遍历所有光标可用的位置在判断为便签类型之后勾选单项框
        for (int i = 0; i < getCount(); i++) {
            if (cursor.moveToPosition(i)) {
                if (NoteItemData.getNoteType(cursor) == Notes.TYPE_NOTE) {
                    setCheckedItem(i, checked);
                }
            }
        }
    }


    /**
     * @description 描述:建立选择项的下标列表
     * @param 参数1:
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:HashSet返回建立的列表
     * @author zhangchaoqun
     */
    public HashSet<Long> getSelectedItemIds() {
        //建立hash表
        HashSet<Long> itemSet = new HashSet<Long>();
        //遍历所有的关键
        for (Integer position : mSelectedIndex.keySet()) {
            //若光标位置可用
            if (mSelectedIndex.get(position) == true) {
                Long id = getItemId(position);
                //原文件不需要添加
                if (id == Notes.ID_ROOT_FOLDER) {
                    Log.d(TAG, "Wrong item id, should not happen");
                }
                //否则将id该下标加入选项集合中
                else {
                    itemSet.add(id);
                }
            }
        }

        return itemSet;
    }


    /**
     * @description 描述:建立桌面Widget的选项表
     * @param 参数1:
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:HashSet桌面widget选项表
     * @author zhangchaoqun
     */
    public HashSet<AppWidgetAttribute> getSelectedWidget() {
        HashSet<AppWidgetAttribute> itemSet = new HashSet<AppWidgetAttribute>();
        for (Integer position : mSelectedIndex.keySet()) {
            if (mSelectedIndex.get(position) == true) {
                Cursor c = (Cursor) getItem(position);
                //光标位置可用的话就建立新的Widget属性并编辑下标和类型，最后添加到选项集中
                if (c != null) {
                    AppWidgetAttribute widget = new AppWidgetAttribute();
                    NoteItemData item = new NoteItemData(mContext, c);
                    widget.widgetId = item.getWidgetId();
                    widget.widgetType = item.getWidgetType();
                    itemSet.add(widget);
                    /**
                     * Don't close cursor here, only the adapter could close it
                     */
                } else {
                    Log.e(TAG, "Invalid cursor");
                    return null;
                }
            }
        }
        return itemSet;
    }


    /**
     * @description 描述:获取选项个数
     * @param 参数1:
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:int选项个数
     * @author zhangchaoqun
     */
    public int getSelectedCount() {
        //首先获取选项下标的值
        Collection<Boolean> values = mSelectedIndex.values();
        if (null == values) {
            return 0;
        }
        //初始化叠加器
        Iterator<Boolean> iter = values.iterator();
        int count = 0;
        while (iter.hasNext()) {
            //若value值为真计数则+1
            if (true == iter.next()) {
                count++;
            }
        }
        return count;
    }


    /**
     * @description 描述:判断是否全部选中
     * @param 参数1:
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:boolean是否全选
     * @author zhangchaoqun
     */
    public boolean isAllSelected() {
        //获取选项数看是否等于便签的个数
        int checkedCount = getSelectedCount();
        return (checkedCount != 0 && checkedCount == mNotesCount);
    }


    /**
     * @description 描述:判断是否为选项表，通过传递的下标来确定
     * @param 参数1:position
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:bool是否是选项表
     * @author zhangchaoqun
     */
    public boolean isSelectedItem(final int position) {
        if (null == mSelectedIndex.get(position)) {
            return false;
        }
        return mSelectedIndex.get(position);
    }


    /**
     * @description 描述:在activity内容发生局部变动的时候回调该函数计算便签的数量
     * @param 参数1:
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:void
     * @author zhangchaoqun
     */
    @Override
    protected void onContentChanged() {
        super.onContentChanged();
        calcNotesCount();
    }


    /**
     * @description 描述:在activity光标发生局部变动的时候回调该函数计算便签的数量
     * @param 参数1:cursor
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:void
     * @author zhangchaoqun
     */
    @Override
    public void changeCursor(Cursor cursor) {
        super.changeCursor(cursor);
        calcNotesCount();
    }


    /**
     * @description 描述:计算便签数量
     * @param 参数1:
     * @param 参数2:
     * @param 参数3:
     * @return 返回值:void
     * @author zhangchaoqun
     */
    private void calcNotesCount() {
        mNotesCount = 0;
        //获取总数同时遍历
        for (int i = 0; i < getCount(); i++) {
            Cursor c = (Cursor) getItem(i);
            //若该位置不为空并且文本类型为便签就+1
            if (c != null) {
                if (NoteItemData.getNoteType(c) == Notes.TYPE_NOTE) {
                    mNotesCount++;
                }
            }
            //否则报错
            else {
                Log.e(TAG, "Invalid cursor");
                return;
            }
        }
    }
}
